unit Movement;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Shape1: TShape;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Timer2: TTimer;
    Button4: TButton;
    Panel1: TPanel;
    Shape2: TShape;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
  private
    { Private declarations }
    direction:integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  var SH:Tshape;
  var SH2:Tshape;
  directionv:integer=-1;
implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  direction:=1;
  Timer1.Enabled:=not Timer1.Enabled;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   direction:=-1;
   Timer1.Enabled:=not Timer1.Enabled;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
    Sh:=TShape.Create(Form1);
    Sh.Parent:=Form1;
    Sh.Width:=20;
    Sh.Height:=40;
    Sh.Shape:=stEllipse;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   If SH=NIL then
   Begin ShowMessage('Click first Button3!');
         exit;
   End;
   Timer2.Enabled:=true;
   directionv:=-directionv;
end;

procedure TForm1.FormClick(Sender: TObject);
begin
  Timer2.Enabled:=false;
end;

procedure TForm1.Panel1Click(Sender: TObject);
begin
    Sh2:=TShape.Create(Form1);
    Sh2.Parent:=Form1.Panel1;
    Sh2.Width:=10;
    Sh2.Height:=15;
    Sh2.Shape:=stRoundRect;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
    Shape1.Left:=Shape1.Left+direction;
    if (Shape1.Left+Shape1.Width>=Form1.Width)
      or (Shape1.Left<0)
    then Timer1.Enabled:=false
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
    Sh.top:=Sh.top+directionv;
    if (Sh.top+Sh.Height>=Form1.Height)
      or (Sh.Top<0)
    then Timer2.Enabled:=false
end;

end.
